/*
 * NetworkTopology.cpp
 *
 *  Created on: 09.04.2009
 *      Author: ingmar
 */

#include "NetworkTopology.h"

NetworkTopology::NetworkTopology() {
}

NetworkTopology::~NetworkTopology() {
}

ID NetworkTopology::getMyId() const {
	return myID;
}

void NetworkTopology::setMyId(ID id) {
	this->myID = id;
}


void NetworkTopology::setMyReceiverReference(RTDS_QueueId reference) {
  this->myReceiverReference = reference;
}

RTDS_QueueId NetworkTopology::getMyReceiverReference() const {
  return myReceiverReference;
}

void NetworkTopology::setConnectivity(ID id, double connectivity) {
	connectivityMap[id] = connectivity;
}

double NetworkTopology::getConnectivity(ID id) {
	return connectivityMap[id];
}

double NetworkTopology::getConnectivity(RTDS_QueueId reference) {
//	ID id = nodeIds[reference];
	return connectivityMap[nodeIds[reference]];
}

void NetworkTopology::setIdReferenceMapping(ID id, RTDS_QueueId receiver_reference, RTDS_QueueId sender_reference) {
	transportReceiverReferences[id] = receiver_reference;
	transportSenderReferences[id] = sender_reference;
	nodeIds[receiver_reference] = id;
	nodeIds[sender_reference] = id;
	
}

ID NetworkTopology::getIDbyReference(RTDS_QueueId reference) {
  return nodeIds[reference];
} 
RTDS_QueueId NetworkTopology::getReceiverReference(ID id) {
  return transportReceiverReferences[id];
}

RTDS_QueueId NetworkTopology::getSenderReference(ID id) {
  return transportSenderReferences[id];
}

std::list<RTDS_QueueId> NetworkTopology::getAllConnectedReferences() {
  std::list<RTDS_QueueId> connectedReferences;
  std::map<ID,RTDS_QueueId>::iterator it;
  for (it = transportReceiverReferences.begin(); it != transportReceiverReferences.end(); it++) {
    connectedReferences.push_back((*it).second);
  }
  return connectedReferences;
}
